Index: /trunk/source/Lib/TLibCommon/TComRdCost.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComRdCost.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComRdCost.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -41,4 +41,10 @@
 #include "TComRom.h"
 #include "TComRdCost.h"
+
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+#include <emmintrin.h>
+#include <xmmintrin.h>
+#endif
+
 #if NH_3D_VSO
 #include "TComDataCU.h"
@@ -208,5 +214,5 @@
   m_bUseEstimatedVSD        = false; 
 #endif
-#if NH_3D_DBBP
+#if NH_3D
   m_bUseMask                = false;
 #endif
@@ -237,5 +243,5 @@
   rcDistParam.DistFunc = m_afpDistortFunc[eDFunc + g_aucConvertToBit[ rcDistParam.iCols ] + 1 ];
 
-#if NH_3D_DBBP
+#if NH_3D
   if( m_bUseMask )
   {
@@ -298,5 +304,5 @@
   }
 
-#if NH_3D_DBBP
+#if NH_3D
   if( m_bUseMask )
   {
@@ -349,5 +355,5 @@
   }
 
-#if NH_3D_DBBP
+#if NH_3D
   if( m_bUseMask )
   {
@@ -372,5 +378,5 @@
   rcDP.DistFunc   = m_afpDistortFunc[ ( bHadamard ? DF_HADS : DF_SADS ) + g_aucConvertToBit[ iWidth ] + 1 ];
   rcDP.m_maximumDistortionForEarlyExit = std::numeric_limits<Distortion>::max();
-#if NH_3D_DBBP
+#if NH_3D
   if( m_bUseMask )
   {
@@ -391,5 +397,9 @@
       for ( x=0; x<iWidth; x+= 8 )
       {
-        uiSum += xCalcHADs8x8( &pi0[x], &pi1[x], iStride0, iStride1, 1 );
+        uiSum += xCalcHADs8x8( &pi0[x], &pi1[x], iStride0, iStride1, 1
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+          , bitDepth
+#endif
+          );
       }
       pi0 += iStride0*8;
@@ -415,5 +425,5 @@
 }
 
-#if NH_3D_ENC_DEPTH
+#if NH_3D
 UInt TComRdCost::calcVAR (Pel* pi0, Int stride, Int width, Int height, Int cuDepth, UInt maxCuWidth)
 { 
@@ -465,8 +475,6 @@
   cDtParam.bitDepth     = bitDepth;
 
-#if NH_3D_IC
+#if NH_3D
   cDtParam.bUseIC       = false;
-#endif
-#if NH_3D_SDC_INTER
   cDtParam.bUseSDCMRSAD = false;
 #endif
@@ -481,4 +489,161 @@
   }
 }
+
+// ====================================================================================================================
+// Distortion functions
+// ====================================================================================================================
+
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+inline Int simdSADLine4n16b( const Pel * piOrg , const Pel * piCur , Int nWidth )
+{
+  // internal bit-depth must be 12-bit or lower
+  assert( !( nWidth & 0x03 ) );
+  __m128i org , cur , abs , sum;
+  sum = _mm_setzero_si128();
+  for( Int n = 0 ; n < nWidth ; n += 4 )
+  {
+    org = _mm_loadl_epi64( ( __m128i* )( piOrg + n ) );
+    cur = _mm_loadl_epi64( ( __m128i* )( piCur + n ) );
+    abs = _mm_subs_epi16( _mm_max_epi16( org , cur )  , _mm_min_epi16( org , cur ) );
+    sum = _mm_adds_epu16( abs , sum );
+  }
+  __m128i zero =  _mm_setzero_si128();
+  sum = _mm_unpacklo_epi16( sum , zero );
+  sum = _mm_add_epi32( sum , _mm_shuffle_epi32( sum , _MM_SHUFFLE( 2 , 3 , 0 , 1 ) ) );
+  sum = _mm_add_epi32( sum , _mm_shuffle_epi32( sum , _MM_SHUFFLE( 1 , 0 , 3 , 2 ) ) );
+  return( _mm_cvtsi128_si32( sum ) );
+}
+
+inline Int simdSADLine8n16b( const Pel * piOrg , const Pel * piCur , Int nWidth )
+{
+  // internal bit-depth must be 12-bit or lower
+  assert( !( nWidth & 0x07 ) );
+  __m128i org , cur , abs , sum;
+  sum = _mm_setzero_si128();
+  for( Int n = 0 ; n < nWidth ; n += 8 )
+  {
+    org = _mm_loadu_si128( ( __m128i* )( piOrg + n ) );
+    cur = _mm_loadu_si128( ( __m128i* )( piCur + n ) );
+    abs = _mm_subs_epi16( _mm_max_epi16( org , cur )  , _mm_min_epi16( org , cur ) );
+    sum = _mm_adds_epu16( abs , sum );
+  }
+  __m128i zero =  _mm_setzero_si128();
+  __m128i hi = _mm_unpackhi_epi16( sum , zero );
+  __m128i lo = _mm_unpacklo_epi16( sum , zero );
+  sum = _mm_add_epi32( lo , hi );
+  sum = _mm_add_epi32( sum , _mm_shuffle_epi32( sum , _MM_SHUFFLE( 2 , 3 , 0 , 1 ) ) );
+  sum = _mm_add_epi32( sum , _mm_shuffle_epi32( sum , _MM_SHUFFLE( 1 , 0 , 3 , 2 ) ) );
+  return( _mm_cvtsi128_si32( sum ) );
+}
+
+inline Void simd8x8Transpose32b( __m128i * pBuffer )
+{
+  __m128 tmp[16];
+  for( Int n = 0 ; n < 16 ; n++ )
+  {
+    tmp[n] = _mm_castsi128_ps( pBuffer[n] );
+  }
+  _MM_TRANSPOSE4_PS( tmp[0] , tmp[2] , tmp[4] , tmp[6] );
+  _MM_TRANSPOSE4_PS( tmp[1] , tmp[3] , tmp[5] , tmp[7] );
+  _MM_TRANSPOSE4_PS( tmp[8] , tmp[10] , tmp[12] , tmp[14] );
+  _MM_TRANSPOSE4_PS( tmp[9] , tmp[11] , tmp[13] , tmp[15] );
+  for( Int n = 0 ; n < 8 ; n += 2 )
+  {
+    pBuffer[n] = _mm_castps_si128( tmp[n] );
+    pBuffer[n+1]  = _mm_castps_si128( tmp[n+8] );
+    pBuffer[n+8] = _mm_castps_si128( tmp[n+1] );
+    pBuffer[n+9]  = _mm_castps_si128( tmp[n+9] );
+  }
+}
+
+#ifdef __GNUC__
+#define GCC_VERSION (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__)
+#if GCC_VERSION > 40600 && GCC_VERSION < 40700
+__attribute__((optimize("no-tree-vrp")))
+#endif
+#endif
+Void simd8x8HAD1D32b( __m128i * pInput , __m128i * pOutput )
+{
+  __m128i m1[8][2] , m2[8][2];
+
+  m2[0][0] = _mm_add_epi32( pInput[0] ,pInput[8 ] );  m2[0][1] = _mm_add_epi32( pInput[1] ,pInput[9 ] );
+  m2[1][0] = _mm_add_epi32( pInput[2] ,pInput[10] );  m2[1][1] = _mm_add_epi32( pInput[3] ,pInput[11] );
+  m2[2][0] = _mm_add_epi32( pInput[4] ,pInput[12] );  m2[2][1] = _mm_add_epi32( pInput[5] ,pInput[13] );
+  m2[3][0] = _mm_add_epi32( pInput[6] ,pInput[14] );  m2[3][1] = _mm_add_epi32( pInput[7] ,pInput[15] );
+  m2[4][0] = _mm_sub_epi32( pInput[0] ,pInput[8 ] );  m2[4][1] = _mm_sub_epi32( pInput[1] ,pInput[9 ] );
+  m2[5][0] = _mm_sub_epi32( pInput[2] ,pInput[10] );  m2[5][1] = _mm_sub_epi32( pInput[3] ,pInput[11] );
+  m2[6][0] = _mm_sub_epi32( pInput[4] ,pInput[12] );  m2[6][1] = _mm_sub_epi32( pInput[5] ,pInput[13] );
+  m2[7][0] = _mm_sub_epi32( pInput[6] ,pInput[14] );  m2[7][1] = _mm_sub_epi32( pInput[7] ,pInput[15] );
+
+  m1[0][0] = _mm_add_epi32( m2[0][0] , m2[2][0] );  m1[0][1] = _mm_add_epi32( m2[0][1] , m2[2][1] );
+  m1[1][0] = _mm_add_epi32( m2[1][0] , m2[3][0] );  m1[1][1] = _mm_add_epi32( m2[1][1] , m2[3][1] );
+  m1[2][0] = _mm_sub_epi32( m2[0][0] , m2[2][0] );  m1[2][1] = _mm_sub_epi32( m2[0][1] , m2[2][1] );
+  m1[3][0] = _mm_sub_epi32( m2[1][0] , m2[3][0] );  m1[3][1] = _mm_sub_epi32( m2[1][1] , m2[3][1] );
+  m1[4][0] = _mm_add_epi32( m2[4][0] , m2[6][0] );  m1[4][1] = _mm_add_epi32( m2[4][1] , m2[6][1] );
+  m1[5][0] = _mm_add_epi32( m2[5][0] , m2[7][0] );  m1[5][1] = _mm_add_epi32( m2[5][1] , m2[7][1] );
+  m1[6][0] = _mm_sub_epi32( m2[4][0] , m2[6][0] );  m1[6][1] = _mm_sub_epi32( m2[4][1] , m2[6][1] );
+  m1[7][0] = _mm_sub_epi32( m2[5][0] , m2[7][0] );  m1[7][1] = _mm_sub_epi32( m2[5][1] , m2[7][1] );
+
+  pInput[0 ] = _mm_add_epi32( m1[0][0] , m1[1][0] );  pInput[1 ] = _mm_add_epi32( m1[0][1] , m1[1][1] );
+  pInput[2 ] = _mm_sub_epi32( m1[0][0] , m1[1][0] );  pInput[3 ] = _mm_sub_epi32( m1[0][1] , m1[1][1] );
+  pInput[4 ] = _mm_add_epi32( m1[2][0] , m1[3][0] );  pInput[5 ] = _mm_add_epi32( m1[2][1] , m1[3][1] );
+  pInput[6 ] = _mm_sub_epi32( m1[2][0] , m1[3][0] );  pInput[7 ] = _mm_sub_epi32( m1[2][1] , m1[3][1] );
+  pInput[8 ] = _mm_add_epi32( m1[4][0] , m1[5][0] );  pInput[9 ] = _mm_add_epi32( m1[4][1] , m1[5][1] );
+  pInput[10] = _mm_sub_epi32( m1[4][0] , m1[5][0] );  pInput[11] = _mm_sub_epi32( m1[4][1] , m1[5][1] );
+  pInput[12] = _mm_add_epi32( m1[6][0] , m1[7][0] );  pInput[13] = _mm_add_epi32( m1[6][1] , m1[7][1] );
+  pInput[14] = _mm_sub_epi32( m1[6][0] , m1[7][0] );  pInput[15] = _mm_sub_epi32( m1[6][1] , m1[7][1] );
+}
+
+inline __m128i simdAbs32b( __m128i m )
+{
+  const __m128i zero = _mm_setzero_si128();
+  __m128i tmp = _mm_sub_epi32( zero , m );
+  __m128i mask = _mm_cmpgt_epi32( m , tmp );
+  return( _mm_or_si128( _mm_and_si128( mask , m ) , _mm_andnot_si128( mask , tmp ) ) );
+}
+
+UInt simdHADs8x8( const Pel * piOrg, const Pel * piCur, Int iStrideOrg, Int iStrideCur )
+{
+  __m128i mmDiff[8][2];
+  __m128i mmZero = _mm_setzero_si128();
+  for( Int n = 0 ; n < 8 ; n++ , piOrg += iStrideOrg , piCur += iStrideCur )
+  {
+    __m128i diff = _mm_sub_epi16( _mm_loadu_si128( ( __m128i* )piOrg ) , _mm_loadu_si128( ( __m128i* )piCur ) );
+    // sign extension
+    __m128i mask = _mm_cmplt_epi16( diff , mmZero );
+    mmDiff[n][0] = _mm_unpacklo_epi16( diff , mask );
+    mmDiff[n][1] = _mm_unpackhi_epi16( diff , mask );
+  }
+
+  // transpose
+  simd8x8Transpose32b( &mmDiff[0][0] );
+
+  // horizontal
+  simd8x8HAD1D32b( &mmDiff[0][0] , &mmDiff[0][0] );
+
+  // transpose
+  simd8x8Transpose32b( &mmDiff[0][0] );
+
+  // vertical
+  simd8x8HAD1D32b( &mmDiff[0][0] , &mmDiff[0][0] );
+
+  __m128i mmSum = _mm_setzero_si128();
+  for( Int n = 0 ; n < 8 ; n++ )
+  {
+    mmSum = _mm_add_epi32( mmSum , simdAbs32b( mmDiff[n][0] ) );
+    mmSum = _mm_add_epi32( mmSum , simdAbs32b( mmDiff[n][1] ) );
+  }
+  mmSum = _mm_add_epi32( mmSum , _mm_shuffle_epi32( mmSum , _MM_SHUFFLE( 2 , 3 , 0 , 1 ) ) );
+  mmSum = _mm_add_epi32( mmSum , _mm_shuffle_epi32( mmSum , _MM_SHUFFLE( 1 , 0 , 3 , 2 ) ) );
+
+  UInt sad = _mm_cvtsi128_si32( mmSum );
+  sad = ( sad + 2 ) >> 2;
+
+  return( sad );
+}
+#endif
+
+
+
 #if NH_3D_VSO
 // SAIT_VSO_EST_A0033
@@ -507,6 +672,4 @@
 #if NH_3D
   cDtParam.bUseIC       = false;
-#endif
-#if NH_3D_SDC_INTER
   cDtParam.bUseSDCMRSAD = false;
 #endif
@@ -554,9 +717,5 @@
 #endif
 
-// ====================================================================================================================
-// Distortion functions
-// ====================================================================================================================
-
-#if NH_3D_DBBP
+#if NH_3D
 // --------------------------------------------------------------------------------------------------------------------
 // Masked distortion functions
@@ -599,7 +758,5 @@
   
   AOF(!pcDtParam->bApplyWeight);
-#if NH_3D_IC
   AOF(!pcDtParam->bUseIC);
-#endif
   
   const Pel* piOrg   = pcDtParam->pOrg;
@@ -674,11 +831,10 @@
     return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
   }
-#if NH_3D_IC
+#if NH_3D
   if( pcDtParam->bUseIC )
   {
     return xGetSADic( pcDtParam );
   }
-#endif
-#if NH_3D_SDC_INTER
+
   if( pcDtParam->bUseSDCMRSAD )
   {
@@ -696,4 +852,29 @@
   Distortion uiSum = 0;
 
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  if( pcDtParam->bitDepth <= 10 )
+  {
+    if( ( iCols & 0x07 ) == 0 )
+    {
+      for( Int iRows   = pcDtParam->iRows ; iRows != 0; iRows-- )
+      {
+        uiSum += simdSADLine8n16b( piOrg , piCur , iCols );
+        piOrg += iStrideOrg;
+        piCur += iStrideCur;
+      }
+    }
+    else
+    {
+      for( Int  iRows   = pcDtParam->iRows; iRows != 0; iRows-- )
+      {
+        uiSum += simdSADLine4n16b( piOrg , piCur , iCols );
+        piOrg += iStrideOrg;
+        piCur += iStrideCur;
+      }
+    }
+  }
+  else
+  {
+#endif
   for(Int iRows = pcDtParam->iRows ; iRows != 0; iRows-- )
   {
@@ -709,4 +890,7 @@
     piCur += iStrideCur;
   }
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  }
+#endif
 
   return ( uiSum >> distortionShift );
@@ -720,11 +904,9 @@
   }
 
-#if NH_3D_IC
+#if NH_3D
   if( pcDtParam->bUseIC )
   {
     return xGetSAD4ic( pcDtParam );
   }
-#endif
-#if NH_3D_SDC_INTER
   if( pcDtParam->bUseSDCMRSAD )
   {
@@ -743,4 +925,17 @@
   Distortion uiSum = 0;
 
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  if( pcDtParam->bitDepth <= 10 )
+  {
+    for( ; iRows != 0; iRows-=iSubStep )
+    {
+      uiSum += simdSADLine4n16b( piOrg , piCur , 4 );
+      piOrg += iStrideOrg;
+      piCur += iStrideCur;
+    }
+  }
+  else
+  {
+#endif
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -753,4 +948,7 @@
     piCur += iStrideCur;
   }
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  }
+#endif
 
   uiSum <<= iSubShift;
@@ -765,11 +963,9 @@
   }
 
-#if NH_3D_IC
+#if NH_3D
   if( pcDtParam->bUseIC )
   {
     return xGetSAD8ic( pcDtParam );
   }
-#endif
-#if NH_3D_SDC_INTER
   if( pcDtParam->bUseSDCMRSAD )
   {
@@ -788,4 +984,17 @@
   Distortion uiSum = 0;
 
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  if( pcDtParam->bitDepth <= 10 )
+  {
+    for( ; iRows != 0; iRows-=iSubStep )
+    {
+      uiSum += simdSADLine8n16b( piOrg , piCur , 8 );
+      piOrg += iStrideOrg;
+      piCur += iStrideCur;
+    }
+  }
+  else
+  {
+#endif
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -802,4 +1011,7 @@
     piCur += iStrideCur;
   }
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  }
+#endif
 
   uiSum <<= iSubShift;
@@ -814,11 +1026,9 @@
   }
 
-#if NH_3D_IC
+#if NH_3D
   if( pcDtParam->bUseIC )
   {
     return xGetSAD16ic( pcDtParam );
   }
-#endif
-#if NH_3D_SDC_INTER
   if( pcDtParam->bUseSDCMRSAD )
   {
@@ -837,4 +1047,17 @@
   Distortion uiSum = 0;
 
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  if( pcDtParam->bitDepth <= 10 )
+  {
+    for( ; iRows != 0; iRows-=iSubStep )
+    {
+      uiSum += simdSADLine8n16b( piOrg , piCur , 16 );
+      piOrg += iStrideOrg;
+      piCur += iStrideCur;
+    }
+  }
+  else
+  {
+#endif
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -859,4 +1082,7 @@
     piCur += iStrideCur;
   }
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  }
+#endif
 
   uiSum <<= iSubShift;
@@ -870,11 +1096,9 @@
     return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
   }
-#if NH_3D_IC
+#if NH_3D
   if( pcDtParam->bUseIC )
   {
     return xGetSAD12ic( pcDtParam );
   }
-#endif
-#if NH_3D_SDC_INTER
   if( pcDtParam->bUseSDCMRSAD )
   {
@@ -918,11 +1142,9 @@
 Distortion TComRdCost::xGetSAD16N( DistParam* pcDtParam )
 {
-#if NH_3D_IC
+#if NH_3D
   if( pcDtParam->bUseIC )
   {
     return xGetSAD16Nic( pcDtParam );
   }
-#endif
-#if NH_3D_SDC_INTER
   if( pcDtParam->bUseSDCMRSAD )
   {
@@ -942,4 +1164,17 @@
   Distortion uiSum = 0;
 
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  if( pcDtParam->bitDepth <= 10 )
+  {
+    for( ; iRows != 0; iRows-=iSubStep )
+    {
+      uiSum += simdSADLine8n16b( piOrg , piCur , iCols );
+      piOrg += iStrideOrg;
+      piCur += iStrideCur;
+    }
+  }
+  else
+  {
+#endif
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -966,4 +1201,7 @@
     piCur += iStrideCur;
   }
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  }
+#endif
 
   uiSum <<= iSubShift;
@@ -978,11 +1216,9 @@
   }
 
-#if NH_3D_IC
+#if NH_3D
   if( pcDtParam->bUseIC )
   {
     return xGetSAD32ic( pcDtParam );
   }
-#endif
-#if NH_3D_SDC_INTER
   if( pcDtParam->bUseSDCMRSAD )
   {
@@ -1001,4 +1237,17 @@
   Distortion uiSum = 0;
 
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  if( pcDtParam->bitDepth <= 10 )
+  {
+    for( ; iRows != 0; iRows-=iSubStep )
+    {
+      uiSum += simdSADLine8n16b( piOrg , piCur , 32 );
+      piOrg += iStrideOrg;
+      piCur += iStrideCur;
+    }
+  }
+  else
+  {
+#endif
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -1039,4 +1288,7 @@
     piCur += iStrideCur;
   }
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  }
+#endif
 
   uiSum <<= iSubShift;
@@ -1051,11 +1303,9 @@
   }
 
-#if NH_3D_IC
+#if NH_3D
   if( pcDtParam->bUseIC )
   {
     return xGetSAD24ic( pcDtParam );
   }
-#endif
-#if NH_3D_SDC_INTER
   if( pcDtParam->bUseSDCMRSAD )
   {
@@ -1074,4 +1324,17 @@
   Distortion uiSum = 0;
 
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  if( pcDtParam->bitDepth <= 10 )
+  {
+    for( ; iRows != 0; iRows-=iSubStep )
+    {
+      uiSum += simdSADLine8n16b( piOrg , piCur , 24 );
+      piOrg += iStrideOrg;
+      piCur += iStrideCur;
+    }
+  }
+  else
+  {
+#endif
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -1104,4 +1367,7 @@
     piCur += iStrideCur;
   }
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  }
+#endif
 
   uiSum <<= iSubShift;
@@ -1116,11 +1382,9 @@
   }
 
-#if NH_3D_IC
+#if NH_3D
   if( pcDtParam->bUseIC )
   {
     return xGetSAD64ic( pcDtParam );
   }
-#endif
-#if NH_3D_SDC_INTER
   if( pcDtParam->bUseSDCMRSAD )
   {
@@ -1139,4 +1403,17 @@
   Distortion uiSum = 0;
 
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  if( pcDtParam->bitDepth <= 10 )
+  {
+    for( ; iRows != 0; iRows-=iSubStep )
+    {
+      uiSum += simdSADLine8n16b( piOrg , piCur , 64 );
+      piOrg += iStrideOrg;
+      piCur += iStrideCur;
+    }
+  }
+  else
+  {
+#endif
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -1209,4 +1486,7 @@
     piCur += iStrideCur;
   }
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  }
+#endif
 
   uiSum <<= iSubShift;
@@ -1220,11 +1500,9 @@
     return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
   }
-#if NH_3D_IC
+#if NH_3D
   if( pcDtParam->bUseIC )
   {
     return xGetSAD48ic( pcDtParam );
   }
-#endif
-#if NH_3D_SDC_INTER
   if( pcDtParam->bUseSDCMRSAD )
   {
@@ -1243,4 +1521,17 @@
   Distortion uiSum = 0;
 
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  if( pcDtParam->bitDepth <= 10 )
+  {
+    for( ; iRows != 0; iRows-=iSubStep )
+    {
+      uiSum += simdSADLine8n16b( piOrg , piCur , 48 );
+      piOrg += iStrideOrg;
+      piCur += iStrideCur;
+    }
+  }
+  else
+  {
+#endif
   for( ; iRows != 0; iRows-=iSubStep )
   {
@@ -1297,5 +1588,7 @@
     piCur += iStrideCur;
   }
-
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  }
+#endif
   uiSum <<= iSubShift;
   return ( uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8) );
@@ -1303,5 +1596,5 @@
 
 
-#if NH_3D_IC || NH_3D_SDC_INTER
+#if NH_3D
 UInt TComRdCost::xGetSADic( DistParam* pcDtParam )
 {
@@ -3138,6 +3431,16 @@
 }
 
-Distortion TComRdCost::xCalcHADs8x8( const Pel *piOrg, const Pel *piCur, Int iStrideOrg, Int iStrideCur, Int iStep )
-{
+Distortion TComRdCost::xCalcHADs8x8( const Pel *piOrg, const Pel *piCur, Int iStrideOrg, Int iStrideCur, Int iStep
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  , Int bitDepth
+#endif
+  )
+{
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  if( bitDepth <= 10 )
+{
+    return( simdHADs8x8( piOrg , piCur , iStrideOrg , iStrideCur ) );
+  }
+#endif
   Int k, i, j, jj;
   Distortion sad = 0;
@@ -3242,11 +3545,9 @@
     return TComRdCostWeightPrediction::xGetHADsw( pcDtParam );
   }
-#if NH_3D_IC
+#if NH_3D
   if( pcDtParam->bUseIC )
   {
     return xGetHADsic( pcDtParam );
   }
-#endif
-#if NH_3D_SDC_INTER
   if( pcDtParam->bUseSDCMRSAD )
   {
@@ -3275,5 +3576,9 @@
       for ( x=0; x<iCols; x+= 8 )
       {
-        uiSum += xCalcHADs8x8( &piOrg[x], &piCur[x*iStep], iStrideOrg, iStrideCur, iStep );
+        uiSum += xCalcHADs8x8( &piOrg[x], &piCur[x*iStep], iStrideOrg, iStrideCur, iStep
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+          , pcDtParam->bitDepth
+#endif
+                            );
       }
       piOrg += iOffsetOrg;
@@ -3318,5 +3623,5 @@
 }
 
-#if NH_3D_IC || NH_3D_SDC_INTER
+#if NH_3D
 UInt TComRdCost::xGetHADsic( DistParam* pcDtParam )
 {
@@ -3389,5 +3694,9 @@
       for ( x=0; x<iCols; x+= 8 )
       {
-        uiSum += xCalcHADs8x8( &tempOrgMinusDeltaDc[x], &piCur[x*iStep], iStrideOrg, iStrideCur, iStep );
+        uiSum += xCalcHADs8x8( &tempOrgMinusDeltaDc[x], &piCur[x*iStep], iStrideOrg, iStrideCur, iStep 
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+          , pcDtParam->bitDepth
+#endif    
+          );
       }
       tempOrgMinusDeltaDc += iOffsetOrg;
@@ -3470,6 +3779,5 @@
   m_uiLambdaMotionSSEVSO = (UInt)floor(65536.0 *       m_dLambdaVSO    );
 }
-#endif
-#if NH_3D_VSO
+
 Dist TComRdCost::xGetDistVSOMode4( Int iStartPosX, Int iStartPosY, Pel* piCur, Int iCurStride, Pel* piOrg, Int iOrgStride, UInt uiBlkWidth, UInt uiBlkHeight, Bool bSAD )
 { 
@@ -3626,3 +3934,4 @@
 #endif
 
+
 //! \}
Index: /trunk/source/Lib/TLibCommon/TComRdCost.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComRdCost.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComRdCost.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -90,8 +90,6 @@
   Int   iStrideVir;
 #endif
-#if NH_3D_IC
+#if NH_3D
   Bool  bUseIC;
-#endif
-#if NH_3D_SDC_INTER
   Bool  bUseSDCMRSAD;
 #endif
@@ -136,5 +134,5 @@
     iStrideVir = 0;
 #endif
-#if NH_3D_SDC_INTER
+#if NH_3D
     bUseSDCMRSAD = false;
 #endif
@@ -165,5 +163,5 @@
   Double                  m_motionLambda;
   Int                     m_iCostScale;
-#if NH_3D_DBBP
+#if NH_3D
   Bool                    m_bUseMask;
 #endif
@@ -204,5 +202,5 @@
   Void    setDistParam( DistParam& rcDP, Int bitDepth, const Pel* p1, Int iStride1, const Pel* p2, Int iStride2, Int iWidth, Int iHeight, Bool bHadamard = false );
 
-#if NH_3D_DBBP
+#if NH_3D
   Void    setUseMask(Bool b) { m_bUseMask = b; }
 #endif
@@ -210,5 +208,5 @@
   Distortion calcHAD(Int bitDepth, const Pel* pi0, Int iStride0, const Pel* pi1, Int iStride1, Int iWidth, Int iHeight );
 
-#if NH_3D_ENC_DEPTH
+#if NH_3D
   UInt    calcVAR(Pel* pi0, Int stride, Int width, Int height, Int cuDepth, UInt maxCuWidth );
 #endif  
@@ -242,5 +240,5 @@
   static Distortion xGetSSE64         ( DistParam* pcDtParam );
   static Distortion xGetSSE16N        ( DistParam* pcDtParam );
-#if NH_3D_IC || NH_3D_SDC_INTER
+#if NH_3D
   static UInt xGetSADic         ( DistParam* pcDtParam );
   static UInt xGetSAD4ic        ( DistParam* pcDtParam );
@@ -269,5 +267,5 @@
 #endif
 
-#if NH_3D_IC || NH_3D_SDC_INTER
+#if NH_3D
   static UInt xGetSAD12ic       ( DistParam* pcDtParam );
   static UInt xGetSAD24ic       ( DistParam* pcDtParam );
@@ -280,5 +278,5 @@
 
 
-#if NH_3D_IC || NH_3D_SDC_INTER
+#if NH_3D
   static UInt xGetHADsic          ( DistParam* pcDtParam );
 #endif
@@ -287,6 +285,10 @@
   static Distortion xCalcHADs2x2      ( const Pel *piOrg, const Pel *piCurr, Int iStrideOrg, Int iStrideCur, Int iStep );
   static Distortion xCalcHADs4x4      ( const Pel *piOrg, const Pel *piCurr, Int iStrideOrg, Int iStrideCur, Int iStep );
-  static Distortion xCalcHADs8x8      ( const Pel *piOrg, const Pel *piCurr, Int iStrideOrg, Int iStrideCur, Int iStep );
-#if NH_3D_DBBP
+  static Distortion xCalcHADs8x8      ( const Pel *piOrg, const Pel *piCurr, Int iStrideOrg, Int iStrideCur, Int iStep
+#if VECTOR_CODING__DISTORTION_CALCULATIONS && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+                                      , Int bitDepth
+#endif
+                                      );
+#if NH_3D
   static UInt xGetMaskedSSE     ( DistParam* pcDtParam );
   static UInt xGetMaskedSAD     ( DistParam* pcDtParam );
Index: /trunk/source/Lib/TLibCommon/TComRdCostWeightPrediction.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComRdCostWeightPrediction.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComRdCostWeightPrediction.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -74,23 +74,4 @@
   Distortion uiSum = 0;
 
-#if !U0040_MODIFIED_WEIGHTEDPREDICTION_WITH_BIPRED_AND_CLIPPING
-  for(Int iRows = pcDtParam->iRows; iRows != 0; iRows-- )
-  {
-    for (Int n = 0; n < iCols; n++ )
-    {
-      const Pel pred = ( (w0*piCur[n] + round) >> shift ) + offset ;
-
-      uiSum += abs( piOrg[n] - pred );
-    }
-    if (pcDtParam->m_maximumDistortionForEarlyExit <  ( uiSum >> distortionShift))
-    {
-      return uiSum >> distortionShift;
-    }
-    piOrg += iStrideOrg;
-    piCur += iStrideCur;
-  }
-
-  pcDtParam->compIdx = MAX_NUM_COMPONENT;  // reset for DEBUG (assert test)
-#else
   // Default weight
   if (w0 == 1 << shift)
@@ -222,5 +203,4 @@
   }
   //pcDtParam->compIdx = MAX_NUM_COMPONENT;  // reset for DEBUG (assert test)
-#endif
 
   return uiSum >> distortionShift;
@@ -256,19 +236,4 @@
   Distortion sum = 0;
 
-#if !U0040_MODIFIED_WEIGHTEDPREDICTION_WITH_BIPRED_AND_CLIPPING
-  for(Int iRows = pcDtParam->iRows ; iRows != 0; iRows-- )
-  {
-    for (Int n = 0; n < iCols; n++ )
-    {
-      const Pel pred     = ( (w0*piCur[n] + round) >> shift ) + offset ;
-      const Pel residual = piOrg[n] - pred;
-      sum += ( Distortion(residual) * Distortion(residual) ) >> distortionShift;
-    }
-    piOrg += iStrideOrg;
-    piCur += iStrideCur;
-  }
-
-  pcDtParam->compIdx = MAX_NUM_COMPONENT; // reset for DEBUG (assert test)
-#else
   if (pcDtParam->bIsBiPred)
   {
@@ -303,5 +268,4 @@
 
   //pcDtParam->compIdx = MAX_NUM_COMPONENT; // reset for DEBUG (assert test)
-#endif
 
   return sum;
Index: /trunk/source/Lib/TLibCommon/TComRdCostWeightPrediction.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComRdCostWeightPrediction.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComRdCostWeightPrediction.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComRectangle.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComRectangle.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComRectangle.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComRom.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComRom.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComRom.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -253,5 +253,5 @@
     }
   }
-#if NH_3D_DMM
+#if NH_3D
   if( !g_dmmWedgeLists.empty() ) 
   {
@@ -509,5 +509,5 @@
   //0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, DM
   { 0, 1, 2, 2, 2, 2, 3, 5, 7, 8, 10, 12, 13, 15, 17, 18, 19, 20, 21, 22, 23, 23, 24, 24, 25, 25, 26, 27, 27, 28, 28, 29, 29, 30, 31, DM_CHROMA_IDX};
-#if NH_3D_DMM
+#if NH_3D
 // ====================================================================================================================
 // Depth coding modes
@@ -537,5 +537,5 @@
 const Bool g_bEncDecTraceEnable  = true;
 const Bool g_bEncDecTraceDisable = false;
-Bool   g_HLSTraceEnable = false;
+Bool   g_HLSTraceEnable = true;
 Bool   g_bJustDoIt = false;
 UInt64 g_nSymbolCounter = 0;
@@ -790,5 +790,5 @@
 #endif
 #endif
-#if NH_3D_DMM
+#if NH_3D
 std::vector< std::vector<TComWedgelet>  > g_dmmWedgeLists;
 std::vector< std::vector<TComWedgeNode> > g_dmmWedgeNodeLists;
Index: /trunk/source/Lib/TLibCommon/TComRom.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComRom.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComRom.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -39,5 +39,5 @@
 #include<stdio.h>
 #include<iostream>
-#if NH_3D_DMM
+#if NH_3D
 #include "TComWedgelet.h"
 #endif
@@ -91,5 +91,5 @@
 extern const UChar  g_aucIntraModeNumFast_NotUseMPM[MAX_CU_DEPTH];
 extern const UChar  g_chroma422IntraAngleMappingTable[NUM_INTRA_MODE];
-#if NH_3D_DMM
+#if NH_3D
 // ====================================================================================================================
 // Depth coding modes
Index: /trunk/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -655,5 +655,5 @@
   Bool  bPCMFilter = (pcPic->getSlice(0)->getSPS()->getUsePCM() && pcPic->getSlice(0)->getSPS()->getPCMFilterDisableFlag())? true : false;
 
-  if(bPCMFilter || pcPic->getSlice(0)->getPPS()->getTransquantBypassEnableFlag())
+  if(bPCMFilter || pcPic->getSlice(0)->getPPS()->getTransquantBypassEnabledFlag())
   {
     for( UInt ctuRsAddr = 0; ctuRsAddr < pcPic->getNumberOfCtusInFrame() ; ctuRsAddr++ )
Index: /trunk/source/Lib/TLibCommon/TComSampleAdaptiveOffset.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComSampleAdaptiveOffset.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComSampleAdaptiveOffset.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
